#gameboxnetwork
#socket experiments client

#client
from socket import *
import urllib,urllib2
import re


class GameboxListener:
   def __init__(self,listen_ip,listen_port):
      self.listen_ip = listen_ip
      self.listen_port = listen_port
      #ZZZ create server to listen and transfer incoming messages to a queue
      
      


#ZZZ protect things with critical sections

class GameboxNetwork:
   def __init__(self,server='www.mrexcessive.net',port=80,\
            gamebox_url='/games/gameboxnetwork/index.cgi',\
            listen_ip='',listen_port=23443):    # listen_ip in case this box is multihomed
      self.server = server
      self.serverport = port
      self.gamebox_url = gamebox_url
      self.listen_ip = listen_ip
      self.listen_port = listen_port
      self.listen=GameboxListener(listen_ip,listen_port)
      self.network = {}    # the current state of the network. Key is IP:port
      self.ping()
   
   def ping(self):
      params = urllib.urlencode({'clientport': self.listen_port})
      p = urllib2.urlopen('http://' + self.server + self.gamebox_url, params)
      d = p.read()
      print "D=" + repr(d); print "I=" + str(p.info()); print "U=" + str(p.geturl())
      #parse the response and update the network state
      pat = re.compile(r'\n([0-9.]+),([0-9.]+),([0-9.]+)',re.MULTILINE)
      m = re.findall(pat,d)
      #print repr(m)
      for (net_ip,net_port,net_time) in m:
         self.network[net_ip + ':' + net_port] = net_time      # key is IP:port
      print repr(self.network)


if __name__ == '__main__':
   test = GameboxNetwork(listen_port=12345)


