#!/usr/bin/python
#default.py in ./gameboxnetwork
#PG 05mar02  collect clientport from parameters
#PG 02mar02

import cgi
import os
import time
import pickle

fname_connections = 'connections.p'
default_client_port = 23343

form = cgi.FieldStorage()

print "Content-type: text/html\n\n"

#new request so:
#load existing connections file
#add existing IP to ./connect/ by touching a file
#send back list of IPs with self removed (in case proxy has messed with do
# at this end)


#load them
#ZZZ ... do the load ...
try:
 connections = pickle.load(open(fname_connections))
except:
 connections = []
 print "Cannot load connections file"

#the new one
client = os.environ['REMOTE_ADDR']
if form.has_key('clientport'):
 client_port = form['clientport'].value
else:
 client_port = default_client_port
client_time = time.time()

#remove older 5 mins
now_time = time.time()
tooold_time = now_time - (5 * 60)
keep_connections = []
for (c,p,t) in connections:
 if c != client:        # remove any existing ping for this client
  if t > tooold_time:
   keep_connections.append((c,p,t))

#add new
keep_connections.append((client,client_port,client_time))

#send back list, clients own IP at top of list
print "<pre>"
print client + ',' + str(client_port) + ',' + str(client_time)
for (c,p,t) in keep_connections:
 if c != client:
  print c + ',' + str(p) + ',' + str(t)
print "</pre>"

#pickle list to file
pickle.dump(keep_connections,open(fname_connections,'w'))



